// SR2DR

module SR2DR_0dr (C, A, Q_1, Q_0);
  input C;
  input A;
  output Q_1, Q_0;
  wire not_a;

  INV1 inst_not_A (.A(A), .Q(not_A));
  NOR21 inst_Q_1 (.A(not_A), .B(C), .Q(Q_1));
  NOR21 inst_Q_0 (.A(A), .B(C), .Q(Q_0));
endmodule


module SR2DR_1dr (C, A, Q_1, Q_0);
  input C;
  input A;
  output Q_1, Q_0;
  wire not_c, not_Q_0;

  NOR21 inst_not_Q_1 (.A(A), .B(A), .Q(not_Q_1));
  INV1 inst_not_C (.A(C), .Q(not_C));
  NAND21 inst_Q_0 (.A(not_C), .B(A), .Q(Q_0));
  INV1 inst_Q_1 (.A(not_Q_1), .Q(Q_1));
endmodule


//DR2SR

module DR2SR_0dr (C, A_1, A_0, Q);
  input C;
  input A_1, A_0;
  output Q;
  wire not_Q;

  NOR21 inst_not_Q (.A(A_1), .B(Q), .Q(not_Q));
  NOR21 inst_Q (.A(A_0), .B(not_Q), .Q(Q));
endmodule


module DR2SR_1dr (C, A_1, A_0, Q);
  input C;
  input A_1, A_0;
  output Q;
  wire not_Q;

  NAND21 inst_not_Q (.A(A_1), .B(Q), .Q(not_Q));
  NAND21 inst_Q (.A(A_0), .B(not_Q), .Q(Q));
endmodule
